program HW;


DEVICE = mega1284P;



CONST

  // BAUDRATE  = 38400;
  // ProcClock = 16384000;       {Hertz}
  // ((ProcClock+BAUDRATE*8)/(BAUDRATE*16)-1)
  // (((38400*8)+16384000)/(38400*16))-1) = ((307200+16384000)/614400)-1 =
  // (16998400/614400)-1 = 27-1 = 26
  // UBRR_VAL : WORD = 26;
  // UBRR_VAL : WORD = 18;  // 56000  ok
  UBRR_VAL : WORD = 106;  // 9600  ok




  XON  : Byte = $11;
  XOFF : Byte = $13;

  // Befehlscode fuer den Adress Extender
  kein_Code       : Byte = 00;
  LOAD_ADRESS     : Byte = 01;   // laden einer neuen Adresse
  INC_ADRESS      : Byte = 02;   // Inkrement der geladenen Adresse
  ADRESS_TRISTATE : Byte = 03;   // Adressbus auf Treestate setzen
  WAIT_Z80ToBuf   : Byte = 04;   // Wait Z80-Bus to AE-Buffer
  WAIT_BufToBC    : Byte = 05;   // Wait AE-Buffer to Bus-Controller


  // Befehlscode fuer Z80CALL
  BC_CONIN        : Byte = 01;
  BC_CONST        : Byte = 02;
  BC_CONOUT       : Byte = 03;
  BC_COPY_BDOS    : Byte = 04;
  BC_COPY_CCP     : Byte = 05;
  BC_READ_SEC     : Byte = 06;
  BC_WRITE_SEC    : Byte = 07;


{--------------------------------------------------------------}


var

{
UDR1, UBRR1H, UBRR1L, UCSR1C, UCSR1B, UCSR1A
UDR0, UBRR0H, UBRR0L, UCSR0C, UCSR0B, UCSR0A
TWAM, TWCR, TWDR, TWAR, TWSR, TWBR, 
ASSR, OCR2B, OCR2A, OCR2, 
TCNT2, TCCR2, TCCR2B, TCCR2A,
OCR1BH, OCR1BL, OCR1AH, OCR1AL,
ICR1H, ICR1L, 
TCNT1H, TCNT1L, TCCR1C, TCCR1B, TCCR1A
DIDR1, DIDR0,
ADMUX, ADCSRB, ADCSR, ADCSRA, ADCH, ADCL
PCMSK3, 
TIMSK2, TIMSK1, TIMSK0,
PCMSK2, PCMSK1, PCMSK0,
EICRA, PCICR, OSCCAL,
PRR, PRR0,
CLKPR, WDTCR, WDTCSR,
SREG, SPH, SPL, RAMPZ,
SPMCSR, SPMCR, MCUCR, MCUCSR, MCUSR, SMCR,
OCDR, ACSR, SPDR, SPDR0, SPSR, SPSR0, SPCR, SPCR0,
GPIOR2, GPIOR1, 
OCR0B, OCR0, OCR0A,
TCNT0, TCCR0B, TCCR0, TCCR0A,
GTCCR, 
EEARH, EEARL, EEDR, EECR,
GPIOR0,
EIMSK, EIFR, PCIFR,
TIFR2, TIFR1, TIFR0,
}

  PORTD, DDRD, PIND, PORTC, DDRC, PINC, 
  PORTB, DDRB, PINB, PORTA, DDRA, PINA : ByteConReg; 

  UBRR0H, UBRR0L, UCSR0C, UCSR0B, UCSR0A, UDR0 : ByteConVar;
  UBRR0 : WordConVar;


  RXC0[UCSR0A,7]  : Bit;
  TXC0[UCSR0A,6]  : Bit;
  UDRE0[UCSR0A,5] : Bit;



{
PB0 = frei
PB1 = /AECMD   A -> H / AE Command / Work in Mode
PB2 = /BCWCLR  A -> H / BC Wait Clear (Aktiv bei L)
PB3 = BCWA     A -> L / BC Wait (Aktiv bei H)
PB4 = /Z80WA   E -> H / Z80 Wait(Aktiv bei L)
}

  Taste_E[PINB,0]   : bit;
  AECMD_A[PortB,1]  : bit;
  BCWCLR_A[PortB,2] : bit;
  BCWA_A  [PortB,3] : bit;
  Z80WA_E [PINB, 4] : bit;


{
PC0 = /WAIT    E -> X
PC1 = /MREQ    A -> H
PC2 = /IORQ    A -> H
PC3 = /RD      A -> H
PC4 = /WR      A -> H
PC5 = /RESET   A -> H
PC6 = /BUSRQ   A -> H
PC7 = /BUSAK   E <- X
}

  WAIT_E [PINC, 0] : bit;

  MREQ_A [PortC,1] : bit;
  MREQ_E [PINC, 1] : bit;
  MREQ_D [DDRC, 1] : bit;

  IORQ_A [PortC,2] : bit;
  IORQ_E [PINC, 2] : bit;
  IORQ_D [DDRC, 2] : bit;

  RD_A   [PortC,3] : bit;
  RD_E   [PINC, 3] : bit;
  RD_D   [DDRC, 3] : bit;

  WR_A   [PortC,4] : bit;
  WR_E   [PINC, 4] : bit;
  WR_D   [DDRC, 4] : bit;

  RESET_A[PortC,5] : bit;

  BUSRQ_A[PortC,6] : bit;

  BUSAK_E[PINC, 7] : bit;

{
PD0 = RXD0      E <-
PD1 = TXD0      A ->
PD2 = /AECS     A -> H
PD3 = /AERQ     E <- X
PD4 = /Z80CALL  E <- X
PD5 = /Z80AK    A -> H
PD6 = LED_GRUEN A -> L
PD7 = LED_ROT   A -> L
}

  AECS_A [PortD,2]  : bit;
  AERQ_E [PIND,3]   : bit;
  Z80CALL_E[PIND,4] : bit;
  Z80AK_A[PortD,5]  : bit;
  LED_GRUEN[PortD,6]: bit;
  LED_ROT[PortD,7]  : bit;


  Zeichen : Byte;

  loop_in, BIOS_geladen : Boolean;

  RAM_Zelle : Byte;

  ConsoleIn : Byte;

  Write_String : String[30];
  Steuer_String : String[30];
  Anzeige_String : String[30];

  // Variablen fuer die DISK-Verwaltung
  SECTOR, TRACK_L, TRACK_H, DISKNO,
  DMAAD_L, DMAAD_H : Byte;

  Sektor_Puffer : Array [0..127] of Byte;



CONST




RAM_Z80_High   : Byte = $FE;
RAM_Z80CALL_MD : Byte = $80;
RAM_Z80CALL_P1 : Byte = $81;
RAM_Z80CALL_P2 : Byte = $82;
RAM_Z80CALL_P3 : Byte = $83;
RAM_Z80CALL_P4 : Byte = $84;
RAM_Z80CALL_P5 : Byte = $85;
RAM_Z80CALL_P6 : Byte = $86;

{--------------------------------------------------------------}
{ functions }


procedure InitPorts;
begin
  // PORT A = Daten
  DDRA:=  %00000000;


{
PB0 = Taste    E -> L 

PB1 = /AECMD   A -> H / AE Command / Work in Mode
PB2 = /BCWCLR  A -> H / BC Wait Clear (Aktiv bei L)
PB3 = BCWA     A -> L / BC Wait (Aktiv bei H)
PB4 = /Z80WA   E -> H / Z80 Wait(Aktiv bei L)

PB5 = MOSI 
PB6 = MISO 
PB7 = SCK 
}
  // PORT B Voreinstellungen
  PORTB:= %00000111;

  //       EEEEAAEE
  DDRB:=  %00001110;

  // PORT B Voreinstellungen
  PORTB:= %00000111;

{
PC0 = /WAIT    E -> X
PC1 = /MREQ    A -> H
PC2 = /IORQ    A -> H
PC3 = /RD      A -> H
PC4 = /WR      A -> H
PC5 = /RESET   A -> H
PC6 = /BUSRQ   A -> H
PC7 = /BUSAK   E <- X
}

  // PORT C Voreinstellungen (BUSRQ ist aktiv)
  PORTC:= %00111110;

  //       EAAAAAAE
  DDRC:=  %01111110;

  // PORT C Voreinstellungen (BUSRQ ist aktiv)
  PORTC:= %00111110;

{
PD0 = RXD0      E <-
PD1 = TXD0      A ->
PD2 = /AECS     A -> H
PD3 = /AERQ     E <- X
PD4 = /Z80CALL  E <- X
PD5 = /Z80AK    A -> H
PD6 = LED_GRUEN A -> L
PD7 = LED_ROT   A -> L
}
  // PORT D Voreinstellungen
  PORTD:= %00100100;

  //       AAAEEAAE
  DDRD:=  %11100110;

  // PORT D Voreinstellungen
  PORTD:= %00100100;

end InitPorts;




// ******************************
// ***    Hilfssprogramme     ***
// ******************************




PROCEDURE wait_ms(Zeit : Word);
VAR
  w1 : Word;
  w2 : Word;
BEGIN
  for w1:=1 to Zeit do
    for w2:=1 to 720 do // 45 * MHz
    endfor;
  endfor;
END wait_ms;








// ******************************
// *** serielle Schnittstelle ***
// ******************************



procedure INIT_SER_PORT;
begin

{
 Initialisieren der seriellen Schnittstelle
 ---------------------------------------------

; festlegen der Baudrate fuer die serielle Schnittstelle
}

    UBRR0 := UBRR_VAL;

{
Bit 4 – RXEN: Receiver Enable
Bit 3 – TXEN: Transmitter Enable
}
    UCSR0B := %00011000;

{
URSEL UMSEL UPM1 UPM0 USBS UCSZ1 UCSZ0 UCPOL
    1     0    0    0    0     1     1     0
}
    UCSR0C := %10000110;


end INIT_SER_PORT;





procedure RX_Puffer_abfragen;
begin
  // wurde ein Byte durch die UART empfangen, so ist das RXC0-Bit gesetzt
  // ist RXC0-Bit = 0, dann ist der Empfangs-Puffer leer
  if BitHigh(RXC0) then
    Zeichen:=UDR0;
  else
    Zeichen:=0;
  endif; { if BitHigh(RXC0) then }
end RX_Puffer_abfragen;





procedure sende_Zeichen(s_Zeichen : Byte);
begin
  // wenn UDRE0 gesetzt ist, so ist der Puffer leer
  // -> warten solange UDRE0 = 0  
  while BitLow(UDRE0) do
    SetBit(LED_GRUEN); // gruen ein
  endwhile;

  ClearBit(LED_GRUEN); // gruen aus

  UDR0:=s_Zeichen;

end sende_Zeichen; 



procedure sende_HEX_Zeichen(h_Zeichen : Byte);
var
  HexLow : Byte;
  HexHigh : Byte;
begin

  HexHigh:=h_Zeichen and $F0;
  SHR(HexHigh);
  SHR(HexHigh);
  SHR(HexHigh);
  SHR(HexHigh);
  if HexHigh>9 then
    HexHigh:=HexHigh+55;
  else
    HexHigh:=HexHigh+48;
  endif;

  sende_Zeichen(HexHigh); 

  HexLow:=h_Zeichen and $0F;
  if HexLow>9 then
    HexLow:=HexLow+55;
  else
    HexLow:=HexLow+48;
  endif;

  sende_Zeichen(HexLow);

  sende_Zeichen($48); // H

end sende_HEX_Zeichen;



procedure sende_HEX_Zeichen_Ln(Wert_Byte : Byte);
begin
  sende_HEX_Zeichen(Wert_Byte);
  sende_Zeichen($0D); // CR
  sende_Zeichen($0A); // LF
end sende_HEX_Zeichen_Ln;



procedure Write;
var
  c1 : Char;
  Laenge : Byte;
  b1 : Byte;
  b2 : Byte;
begin

  Laenge:=Length(Write_String);
  for b1:=1 to Laenge do
    c1:=Write_String[b1];
    b2:=CharToByte(c1);
    sende_Zeichen(b2);
  endfor;

end Write;




procedure WriteLn;
begin
  Write;
  sende_Zeichen($0D); // CR
  sende_Zeichen($0A); // LF
end WriteLn;





procedure ByteToString(Wert_Byte : Byte);
var
  HexLow : Byte;
  HexHigh : Byte;
  c1 : Char;
begin

  HexHigh:=Wert_Byte and $F0;
  SHR(HexHigh);
  SHR(HexHigh);
  SHR(HexHigh);
  SHR(HexHigh);
  if HexHigh>9 then
    HexHigh:=HexHigh+55;
  else
    HexHigh:=HexHigh+48;
  endif;

  c1:=ByteToChar(HexHigh);
  Write_String:=c1;

  HexLow:=Wert_Byte and $0F;
  if HexLow>9 then
    HexLow:=HexLow+55;
  else
    HexLow:=HexLow+48;
  endif;

  c1:=ByteToChar(HexLow);
  Write_String:=Write_String+c1;

end ByteToString;







function StringToByte : Byte;
var
  HexLow : Byte;
  HexHigh : Byte;
  S2B : Byte;
  c1 : Char;
begin

  c1:=Write_String[1];
  HexHigh:=CharToByte(c1);
  HexHigh:=HexHigh-48;
  if HexHigh>9 then
    HexHigh:=HexHigh-7;
  endif;
  SHL(HexHigh);
  SHL(HexHigh);
  SHL(HexHigh);
  SHL(HexHigh);

  c1:=Write_String[2];
  HexLow:=CharToByte(c1);
  HexLow:=HexLow-48;
  if HexLow>9 then
    HexLow:=HexLow-7;
  endif;

  S2B:=HexHigh+HexLow;

  RESULT:=S2B;

end StringToByte;





// ******************************
// ***   AE-Hilfsprogramme    ***
// ******************************





// ein Byte an AE senden
procedure AE_WRITE_BYTE(WR_Byte : byte);
begin

  // warten bis ATMEGA162 bereit ist
  while BitLow(AERQ_E) do
  endwhile;

  // /AECMD aktiv schalten
  ClearBit(AECMD_A);   

  // Datenbus auf Ausgang
  DDRA:= %11111111; // D0-D7 A

  // Daten auf Datenbus legen
  PORTA:=WR_Byte;

  NOP;
  NOP;
  NOP;
  NOP;
  NOP;
  NOP;

  // AECS_A aktiv schalten (Daten koennen uebernommen werden)
  ClearBit(AECS_A);

  // warten bis Daten uebernommen wurden
  while BitHigh(AERQ_E) do
  endwhile;

  // Betriebsart Programmieren abschalten
  SetBit(AECS_A);  // AECS_A inaktiv

  // Uebertragung abgeschlossen

  DDRA:= %00000000; // Datenbus auf Eingang
  
  SetBit(AECMD_A);    // AECMD_A inaktiv

end AE_WRITE_BYTE; 






procedure AE_WRITE_ADRESS(a16, a08, a00 : byte);
begin

  AE_WRITE_BYTE(LOAD_ADRESS);

  // adr_00_07
  AE_WRITE_BYTE(a00);

  // adr_08_15
  AE_WRITE_BYTE(a08);

  // adr_16_18
  AE_WRITE_BYTE(a16);

end AE_WRITE_ADRESS;



// ******************************
// ***   RAM-Hilfsprogramme   ***
// ******************************









// ******************************
// ***   BUS-Hilfsprogramme   ***
// ******************************





procedure BC_Bus_anfordern;
begin

  // Busanforderung an Z80
  SetBit(LED_ROT);
  ClearBit(BUSRQ_A);

  while BitHigh(BUSAK_E) do
  endwhile;

  NOP; 
  NOP;
  NOP; 
  NOP;
 
  {
  PC0 = frei     E -> X
  PC1 = /MREQ    A -> H
  PC2 = /IORQ    A -> H
  PC3 = /RD      A -> H
  PC4 = /WR      A -> H
  PC5 = /RESET   A -> H
  PC6 = /BUSRQ   A -> H
  PC7 = /BUSAK   E <- X
  }

  // PORT C Voreinstellungen (BUSRQ ist aktiv)
  SetBit(MREQ_A);
  SetBit(IORQ_A);
  SetBit(RD_A);
  SetBit(WR_A);


  // PORT C Steuerleitungen als Ausgang schalten
  SetBit(MREQ_D);
  SetBit(IORQ_D);
  SetBit(RD_D);
  SetBit(WR_D);


  // PORT C Voreinstellungen (BUSRQ ist aktiv)
  SetBit(MREQ_A);
  SetBit(IORQ_A);
  SetBit(RD_A);
  SetBit(WR_A);

 

  ClearBit(LED_ROT);

end BC_Bus_anfordern;






procedure BC_Bus_freigeben;
begin

  SetBit(LED_ROT);

  // PORT A = Daten
  DDRA:=  %00000000;

  // PORT B bleibt so

  {
  PC0 = frei     E -> X
  PC1 = /MREQ    A -> H
  PC2 = /IORQ    A -> H
  PC3 = /RD      A -> H
  PC4 = /WR      A -> H
  PC5 = /RESET   A -> H
  PC6 = /BUSRQ   A -> H
  PC7 = /BUSAK   E <- X
  }
  // PORT C Voreinstellungen (BUSRQ ist aktiv), Reset bleibt Ausgang
  // alle anderen Z80-Steuerleitungen werden
  // auf Eingang gestellt und freigegeben

  ClearBit(MREQ_D);
  ClearBit(IORQ_D);
  ClearBit(RD_D);
  ClearBit(WR_D);

  // PORT D bleibt so


  ClearBit(MREQ_A);
  ClearBit(IORQ_A);
  ClearBit(RD_A);
  ClearBit(WR_A);

  NOP; 
  NOP;
  NOP; 
  NOP;
 
  // jetzt wird die Z80 frei gegeben
  SetBit(BUSRQ_A);

  // warten bis Z80 den Bus uebernommen hat
  while BitLow(BUSAK_E) do
  endwhile;

  ClearBit(LED_ROT);

end BC_Bus_freigeben;
















// ***********************************************
// ***** Kommunikationsprogramme mit dem PC  *****
// ***********************************************








// ************************************







procedure Zeichen_auswerten;
begin

  case Zeichen of

    $61 : AE_WRITE_ADRESS(%00000000, %00000000, %00000001);
          sende_Zeichen($41); // a -> A 

    |

    $62 : AE_WRITE_ADRESS(%00000000, %00000000, %00000010);
          sende_Zeichen($42); // b -> B 

    |

    $63 : AE_WRITE_ADRESS(%00000000, %00000000, %00000100);
          sende_Zeichen($43); // c -> C 

    |

    $64 : AE_WRITE_ADRESS(%00000000, %00000000, %00001000);
          sende_Zeichen($44); // d -> D 

    |

    $65 : AE_WRITE_ADRESS(%00000000, %00000000, %00010000);
          sende_Zeichen($45); // e -> E

    |

    $66 : AE_WRITE_ADRESS(%00000000, %00000000, %00100000);
          sende_Zeichen($46); // f -> F

    |

    $67 : AE_WRITE_ADRESS(%00000000, %00000000, %01000000);
          sende_Zeichen($47); // g -> G

    |

    $68 : AE_WRITE_ADRESS(%00000000, %00000000, %10000000);
          sende_Zeichen($48); // h -> H

    |

    $69 : AE_WRITE_ADRESS(%00000000, %00000001, %00000000);
          sende_Zeichen($49); // i -> I

    |

    $6A : AE_WRITE_ADRESS(%00000000, %00000010, %00000000);
          sende_Zeichen($4A); // j -> J

    |

    $6B : AE_WRITE_ADRESS(%00000000, %00000100, %00000000);
          sende_Zeichen($4B); // k -> K

    |

    $6C : AE_WRITE_ADRESS(%00000000, %00001000, %00000000);
          sende_Zeichen($4C); // l -> L

    |

    $6D : AE_WRITE_ADRESS(%00000000, %00010000, %00000000);
          sende_Zeichen($4D); // m -> M

    |

    $6E : AE_WRITE_ADRESS(%00000000, %00100000, %00000000);
          sende_Zeichen($4E); // n -> N

    |

    $6F : AE_WRITE_ADRESS(%00000000, %01000000, %00000000);
          sende_Zeichen($4F); // o -> O

    |

    $70 : AE_WRITE_ADRESS(%00000000, %10000000, %00000000);
          sende_Zeichen($50); // p -> P

    |

    $71 : AE_WRITE_ADRESS(%00000001, %00000000, %00000000);
          sende_Zeichen($51); // q -> Q

    |

    $72 : AE_WRITE_ADRESS(%00000010, %00000000, %00000000);
          sende_Zeichen($52); // r -> R

    |

    $73 : AE_WRITE_ADRESS(%00000100, %00000000, %00000000);
          sende_Zeichen($53); // s -> S

    |

  else
    sende_Zeichen($58); // -> X
  endcase;

  Zeichen:=0;

end Zeichen_auswerten;














{--------------------------------------------------------------}
{ Main Program }
{$IDATA}







begin

ASM;

.equ UBRR0 = UBRR0L

ENDASM;

  // Grundeinstellung der Ports
  InitPorts;

  INIT_SER_PORT;

  ConsoleIn:=0;

  ClearBit(LED_GRUEN);  // LED_GRUEN aus
  ClearBit(LED_ROT);  // LED_ROT aus


  // Abschalten der WAIT-Logik
  ClearBit(BCWA_A);  // High aktiv
  SetBit(BCWCLR_A);  // Low aktiv


  BC_Bus_anfordern;


  loop

    RX_Puffer_abfragen;

    if Zeichen>0 then
      Zeichen_auswerten;
    endif;

  endloop;


end HW.


